## START: Set by rpmautospec
## (rpmautospec version 0.3.5)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# 22 of the 23 provided unit tests require a valid configuration file and certificate.
# The remaining dependency fails due to the dependency adjustments in %%prep
%bcond_with     tests

Name:           oci-cli
Version:        3.31.0
Release:        %autorelease
Summary:        Command Line Interface for Oracle Cloud Infrastructure 

License:        UPL-1.0
URL:            https://github.com/oracle/oci-cli
Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz

BuildArch:      noarch

BuildRequires:  python3-devel

%if %{with tests}
BuildRequires:  python3dist(pytest)
BuildRequires:  python3dist(vcrpy)
%endif

%global _description %{expand:
This is the command line interface for Oracle Cloud Infrastructure.}

%description %{_description}

# Awaiting a fix for python-cx-oracle
# https://src.fedoraproject.org/rpms/python-cx-oracle/pull-request/1
# %%pyproject_extras_subpkg -n %%{name} db


%prep
%autosetup -n %{name}-%{version}

# Allow older versions of pinned dependencies in EPEL.
%if 0%{?el9} || 0%{?centos} >= 9
sed -i 's/click==8.0.4/click>=8.0.3/' setup.py
sed -i 's/jmespath==0.10.0/jmespath>=0.9.4/' setup.py
%endif

# Allow newer version of pinned dependencies.
sed -i 's/click==8.0.4/click>=8.0.4/' setup.py
sed -i 's/jmespath==0.10.0/jmespath>=0.10.0/' setup.py
sed -i 's/prompt-toolkit==3.0.29/prompt-toolkit>=3.0.29/' setup.py
sed -i 's/terminaltables==3.1.0/terminaltables>=3.1.0/' setup.py

# Remove upper version limits.
sed -i 's/cryptography>=3.2.1,<40.0.0/cryptography>=3.2.1/' setup.py
sed -i 's/PyYAML>=5.4,<=6/PyYAML>=5.4/' setup.py


%generate_buildrequires
%pyproject_buildrequires


%build
%pyproject_wheel


%install
%pyproject_install

# Remove extra script that isn't needed.
rm -f %{buildroot}/%{_bindir}/create_backup_from_onprem

%pyproject_save_files common_util interactive oci_cli services


%check
%pyproject_check_import -e 'oci_cli.scripts.database.dbaas' -e 'services.*'

%if %{with tests}
%pytest
%endif


%files -n %{name} -f %{pyproject_files}
%license LICENSE.txt THIRD_PARTY_LICENSES.txt
%doc CHANGELOG.rst COMMON_ISSUES.rst CONTRIBUTING.rst README.rst
%{_bindir}/oci


%changelog
* Wed Aug 16 2023 Major Hayden <major@redhat.com> - 3.31.0-1
- Update to 3.31.0

* Thu Aug 10 2023 Packit <hello@packit.dev> - 3.30.2-1
- [packit] 3.30.2 upstream release

* Wed Aug 02 2023 Packit <hello@packit.dev> - 3.30.1-1
- [packit] 3.30.1 upstream release

* Tue Jul 25 2023 Packit <hello@packit.dev> - 3.30.0-1
- [packit] 3.30.0 upstream release

* Thu Jul 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 3.29.4-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Wed Jul 19 2023 Major Hayden <major@redhat.com> - 3.29.4-2
- Adjust PyYAML pin to allow > 6

* Tue Jul 18 2023 Packit <hello@packit.dev> - 3.29.4-1
- [packit] 3.29.4 upstream release

* Thu Jul 13 2023 Major Hayden <major@mhtx.net> - 3.29.3-2
- RPMAUTOSPEC: unresolvable merge
